/// <reference types="react" />
import Grid, { GridSchema, GridColumnObject } from '../Grid';
import { Schema } from '../../types';
import { FormControlProps, FormBaseControl, FormControlSchema } from './Item';
import { IIRendererStore } from '../../store/iRenderer';
/**
 * Grid 格子布局
 * 文档：https://baidu.gitee.io/amis/docs/components/form/grid
 */
export interface GridControlSchema extends FormBaseControl, Omit<GridSchema, 'columns'> {
    type: 'grid';
    columns: Array<GridColumnObject & {
        /**
         * 表单项集合
         */
        controls?: Array<FormControlSchema>;
        /**
         * @deprecated 请用类型 tabs
         */
        tabs?: any;
        /**
         * @deprecated 请用类型 fieldSet
         */
        fieldSet?: any;
    }>;
}
export interface GridProps extends FormControlProps, Omit<GridControlSchema, 'type' | 'className' | 'descriptionClassName' | 'inputClassName'> {
    store: IIRendererStore;
}
export declare class GridRenderer extends Grid<GridProps> {
    static propsList: Array<string>;
    static defaultProps: {};
    renderChild(region: string, node: Schema, key: number, length: number): JSX.Element;
}
